// ***************************************************************************
// Implementation System Includes
// ***************************************************************************

#include <be/app/Roster.h>
#include <be/be_apps/Deskbar/Deskbar.h>

// ***************************************************************************
// Implementation Project Includes
// ***************************************************************************

#include "WatchApp.h"
#include "WatchView.h"
#include "WebWatch.h"

// ***************************************************************************
// Implementation Constant Definitions
// ***************************************************************************

// ***************************************************************************
// Implementation Type Definitions
// ***************************************************************************

// ***************************************************************************
// Implementation Variable Definitions
// ***************************************************************************

// ***************************************************************************
// Implementation Function Declarations
// ***************************************************************************

// ***************************************************************************
// Global Variable Definitions
// ***************************************************************************

// ***************************************************************************
// PUBLIC Member Function Definitions
// ***************************************************************************

// ===========================================================================
// Constructor
// ===========================================================================

WatchApp::WatchApp() 
	: BApplication(APP_SIGNATURE)
{
	BDeskbar deskbar;

	// For backwards compatibility.
	if (deskbar.HasItem("WebWatch"))
	{
		deskbar.RemoveItem("WebWatch");
	}

	// Only install one copy of WebWatch into the Deskbar.
	if (!deskbar.HasItem(DESKBAR_ITEM_NAME))
	{
		// Find the app's location by the APP_SIGNATURE.
		entry_ref ref;
		be_roster->FindApp(APP_SIGNATURE, &ref);

		// Pass the location of the app to the Deskbar
		// and let it do its magic.
		deskbar.AddItem(&ref);
	}
	
	// Commit suicide.
	PostMessage(B_QUIT_REQUESTED);
}

// ***************************************************************************
// PROTECTED Member Function Definitions
// ***************************************************************************

// ***************************************************************************
// PRIVATE Member Function Definitions
// ***************************************************************************

// ***************************************************************************
// Helper Function Definitions
// ***************************************************************************

// ***************************************************************************
// Global Function Definitions
// ***************************************************************************

// ===========================================================================
// instantiate_deskbar_item
// ===========================================================================

BView*
instantiate_deskbar_item(void)
{
	return new WatchView();
}

// ***************************************************************************
// Implementation Function Definitions
// ***************************************************************************
